//+------------------------------------------------------------------+
//|                                                        Bands.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 LightSeaGreen
//---- indicator parameters
extern int    _ATR=20;
extern double    =2;
extern int _=20;
//---- buffers

double _[];
double _[];
double ATR[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(0,ATR);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,_);
   SetIndexLabel(1,"_"); 
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,_);
   SetIndexLabel(2,"_");
//----
   SetIndexDrawBegin(0,_ATR);
   SetIndexDrawBegin(1,_ATR);
   SetIndexDrawBegin(2,_ATR);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double deviation;
   double sum,oldval,newres;
//----
   if(Bars<=_ATR) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=_ATR;i++)
        {
         ATR[Bars-i]=EMPTY_VALUE;
         _[Bars-i]=EMPTY_VALUE;
         _[Bars-i]=EMPTY_VALUE;
        }
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      ATR[i]=iATR(NULL,0,_ATR,i);
//----
   i=Bars-_ATR+1;
   if(counted_bars>_ATR-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      _[i]=High[iHighest(NULL,0,MODE_HIGH,_,i)]-*ATR[i];
      _[i]=Low[iLowest(NULL,0,MODE_LOW,_,i)]+*ATR[i];
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+